/*

	 THE GAME OF PLOT 4
	 Written By:
		  Gaurang Khetan,
		  Third Year (Electronics),
		  Vishwakarma Institute Of Technology.

	 For:
	 Genesis Prepared Software Competition, 2000
	 Bharti Vidyapeeth College Of Engineering.

	 DATE: Monday, 27-03-2000
*/


#include <ASSERT.H>
#include <DOS.H>
#include <GRAPHICS.H>
#include <CONIO.H>
#include <STDIO.H>
#include <STDLIB.H>
#include "mouse.h"
typedef long signed int score;
typedef signed int id;
typedef signed int movetype;
typedef signed int pos;
typedef unsigned int color;
enum boolean { false, true };
const id id1 = 1, id2 = 5;

#include "PLOT4.H"	//class defintions

display_class d;
board_class brd;
game_class g;
pos board[81];
int order[9] = { 4, 3, 5, 2, 6, 1, 7, 0, 8 };

void main()
	{
	g.intro();

	d.init_graphics();

	while(true)
		{
		d.display_grid();
		brd.reset_board();

		id t = g.play_game();

		if (t==id1)
			{
			d.set_line(0, "Player 1 has won! ");
			sound(200); delay(1000); nosound();
			}
		else if (t==id2)
			{
			d.set_line(0, "Player 2 has won!");
			sound(1000); delay(1000); nosound();
			}
		else
			{
			d.set_line(0, "Game Drawn");
			sound(500); delay(1000); nosound();
			}

		d.set_line(0, "Want to play again? (y/n) ");
		char ch;
		do
			ch = getch();
		while (ch!='y' && ch!='Y' && ch!='n' && ch!='N');
		if (ch=='n' || ch=='N') break;
		}

	d.set_line(0, "Come back again!");

	getch();

	d.end_graphics();

	}

//class display member functions
display_class::display_class()
	{
	cell_hgt = 30; cell_wdth = 30;
	grd_x = 320 - (cell_wdth * 9)/2;
	grd_y = 240 + (cell_hgt * 9)/2;
	piece_rad = 12;

	// the following are the coordinates for lines to be displayed on scrn
	// to facilitate better drawing and erasing of text in graphics mode
	x1[0] = 100; y1[0] = 400; x2[0] = 600; y2[0] = 425;
	x1[1] = 100; y1[1] = 440; x2[1] = 600; y2[1] = 465;
	x1[2] = 1; y1[2] = 400; x2[2] = 639; y2[2] = 425;
	x1[3] = 200; y1[3] = 5; x2[3] = 500; y2[3] = 55;

	//sizes of the text
	size[0] = si7ze[1] = size[2] = size[3] = 1;

	//colors of various objects
	arrow_col = YELLOW;
	back_col = 1;		// background color
	pl1_piece_col = 4; pl2_piece_col = 15;
	grd_back_col = 2; grd_col = 15;
	talk_col[0] = 6;     //colors of text to be displayed on screen
	talk_col[1] = 7;
	talk_col[2] = 8;
	talk_col[3] = 9;

	arrow=0;
	}

void display_class::init_graphics()
	{
	int gd = VGA, gm = VGAHI;
	initgraph(&gd, &gm , "");
	}

void display_class::end_graphics()
	{
	closegraph();
	}

void display_class::set_line(int lineno, char* str)
	{
	if (!cleared[lineno]) clear_line(lineno);

	setcolor(talk_col[lineno]);
	settextstyle(0, 0, size[lineno] );
	outtextxy( (x1[lineno]+x2[lineno])/2 - (textwidth(str)/2),
					(y1[lineno]+y2[lineno])/2 - (textheight(str)/2),
						str);

	cleared[lineno] = false;
	}

void display_class::clear_line (int lineno)
	{
	setfillstyle(SOLID_FILL, back_col);
	bar(x1[lineno], y1[lineno], x2[lineno], y2[lineno]);
	cleared[lineno] = true;
	}

void display_class::display_grid()
	{
	//these are flags to indicate whether text has not been written on scrn
	cleared[0] = cleared[1] = cleared[2] = cleared[3] = true;

	char str[2];

	setbkcolor(back_col);
	cleardevice();

	setfillstyle(SOLID_FILL, back_col);
	bar(0, 0, 639, 479);

	setfillstyle(SOLID_FILL, grd_back_col);
	bar(grd_x, grd_y, grd_x+cell_wdth*9, grd_y-cell_hgt*9);

	setcolor(grd_col);
	settextstyle(0,0,1);

	for (int i=0; i<=9; i++)
		{
		line(grd_x+i*cell_wdth, grd_y,
								grd_x+i*cell_wdth, grd_y-cell_hgt*9);
		line(grd_x, grd_y-i*cell_hgt,
									grd_x+ cell_wdth*9,grd_y-i*cell_hgt);

		str[0] = i+'1'; str[1] = 0;
		if (i!=9)
			outtextxy( grd_x+i*cell_wdth+cell_wdth/2 - 5, grd_y+5, str);
		}

	setcolor(YELLOW);
	settextstyle(0,0,2);
	outtextxy(260, 20, " PLOT 4 ");

	setcolor(YELLOW);
	settextstyle(0,0,1);
	outtextxy(550, 150, " Player 1");
	outtextxy(550, 300, " Player 2");

	setcolor(pl1_piece_col);
	setfillstyle(SOLID_FILL, pl1_piece_col);
	fillellipse(585, 185, piece_rad, piece_rad);

	setcolor(pl2_piece_col);
	setfillstyle(SOLID_FILL, pl2_piece_col);
	fillellipse(585, 335, piece_rad, piece_rad);

	}

void display_class::show_arrow(id who)
	{
	int y;
	if (arrow) clear_arrow();
	if (who==id1) { y = 185; arrow = 1; } else { y = 335; arrow = 2; }

	setcolor(arrow_col);
	moveto(540, y);
	linerel(20,0);
	linerel(-8,-8);
	linerel(8, 8);
	linerel(-8, 8);

	}

void display_class::clear_arrow()
	{
	int y;
	if (arrow==1) y = 185; else y = 335;
	arrow=0;

	setcolor(back_col);
	moveto(540, y);
	linerel(20,0);
	linerel(-8,-8);
	linerel(8, 8);
	linerel(-8, 8);

	}

void display_class::show_piece(pos place, id who)
	{
	int x = grd_x + (place%9) * cell_wdth + cell_wdth/2;
	int y = grd_y - (place/9) * cell_hgt - cell_hgt/2;

	color col;
	if (who==0)
		col = grd_back_col;
	else if (who == id1)
		col = pl1_piece_col;
	else
		col = pl2_piece_col;

	setcolor(col);
	setfillstyle(SOLID_FILL, col);
	fillellipse(x, y, piece_rad, piece_rad);
	}

//class board member functions
board_class::board_class()
	{
	}

void board_class::reset_board()
	{
	for( int i =0; i <= 80; i++)
		board[i] = 0;
	for ( i=0; i<=8; i++)
		tops[i] = 0;
	}

int board_class::top_col(int c)
	{
	return tops[c];
	}

void board_class::play_move(id who, movetype col, boolean disp )
	{

	int t = tops[col];
	if (tops[col]==8) tops[col]=-1; else tops[col]++;
	board[ t*9 + col] = who;

	if (disp)
		d.show_piece(t*9 + col, who);

	}

movetype board_class::next_move(int& k)
	{


	if (k <= 8)
		{
		movetype m;

		for ( m = k; m<= 8; m++)
			if (top_col(order[m]) != -1) break;

		k = m + 1;

		if (k<10) return order[m];
		}
	return -1;
	}

void board_class::back_move(movetype col, boolean disp)
	{
	if (tops[col]==-1) tops[col] = 8; else tops[col]--;
	board[ tops[col]*9 + col] = 0;

	if (disp)
		d.show_piece(  tops[col]*9 + col, 0);
	}

boolean board_class::won_by_this(movetype m)
	{
	int k=tops[m];
	if (k==-1) k=8; else k--;
	int p = k*9 + m;
	id plid = board[p];

	if ( (go_l(plid, p)+go_r(plid, p) >= 3) ||
		 (go_u(plid, p)+go_d(plid, p) >= 3) ||
		 (go_lu(plid, p)+go_rd(plid, p) >= 3) ||
		 (go_ld(plid, p)+go_ru(plid, p) >= 3)  )
		 return true;

	return false;
	}

int board_class::go_u(int pl, int b)
	{
	int t=0;
	while(b<=71)
		{
		b+=9; if (board[b]==pl) t++; else break;
		}
	return t;
	}
int board_class::go_d(int pl, int b)
	{
	int t=0;
	while(b>=9)
		{
		b-=9; if (board[b]==pl) t++; else break;
		}
	return t;
	}
int board_class::go_l(int pl, int b)
	{
	int t=0;
	while((b%9)>=1)
		{
		b--; if (board[b]==pl) t++;  else break;
		}
	return t;
	}
int board_class::go_r(int pl, int b)
	{
	int t=0;
	while(b%9<=7)
		{
		b++; if (board[b]==pl) t++;  else break;
		}
	return t;
	}
int board_class::go_lu(int pl, int b)
	{
	int t=0;
	while( ((b%9)!=0) && (b<=71) )
		{
		b+=8; if (board[b]==pl) t++; else break;
		}
	return t;
	}
int board_class::go_ld(int pl, int b)
	{
	int t=0;
	while( ((b%9)!=0) && (b>=9) )
		{
		b-=10; if (board[b]==pl) t++;else break;
		}
	return t;
	}
int board_class::go_ru(int pl, int b)
	{
	int t=0;
	while( ((b%9)!=8) && (b<=71) )
		{
		b+=10; if (board[b]==pl) t++;else break;
		}
	return t;
	}
int board_class::go_rd(int pl, int b)
	{
	int t=0;
	while( ((b%9)!=8) && (b>=9) )
		{
		b-=8; if (board[b]==pl) t++; else break;
		}
	return t;
	}

id board_class::whowon()
	{
	int hori, vert, k;
	int p;

	for(int t=0; t<=80; t++)
		{
		vert = (t<54)? 1 : 2;
		k = t%9;
		if (k<=2) hori = 1;
		else if (k>=6) hori = 3;
		else hori = 2;

		if (hori!=3)
			{
			p = board[t] + board[t+1] + board[t+2] + board[t+3];
			if (p==id1*4) return id1;
			if (p==id2*4) return id2;
			}

		if (vert == 2) continue;

		p = board[t] + board[t+9] + board[t+18] + board[t+27];
		if (p==id1*4) return id1;
		if (p==id2*4) return id2;

		if (hori!=3)
			{
			p = board[t] + board[t+10] + board[t+20] + board[t+30];
			if (p==id1*4) return id1;
			if (p==id2*4) return id2;
			}

		if (hori!=1)
			{
			p = board[t] + board[t+8] + board[t+16] + board[t+24];
			if (p==id1*4) return id1;
			if (p==id2*4) return id2;
			}
		}
	return false;
	}

boolean board_class::drawn()
	{
	for (int i=0; i <= 80; i++)
		if (board[i] == 0) return false;
	return true;
	}


//class brain member functions
brain_class::brain_class(id for_my_id, int depth )
	{
	my_id = for_my_id;

	//values for different combinations of our pawns in a 4-hole string
	for(int i=0; i<=20; i++)
		value[i] = 0;

	value[1] = 1; value[2] = 2; value[3] = 8; value[4] = 10000;
	value[5] = -1; value[10] = -2; value[15] = -8; value[20] = -10000;

	move = -1;

	start_alpha = -999999L; start_beta = 999999L;
	max_depth = depth;
	}

void brain_class::set_depth(int z)
	{
	max_depth = z;
	}

score brain_class::evaluate(id plid, score alpha, score beta, int depth)
	{
	score v, e;
	boolean done;
	movetype p=-1, best_move=-1;
	int move_count=0;

	if (brd.drawn())
		return 0;

	if (depth >= max_depth)
		{
		v = stat_eval(plid);	//static evaluation when plid is to play
		}
	else
		{
		v = alpha;
		do
			{
			done = false;
			p = brd.next_move(move_count);
			if (p != -1)
				{
				brd.play_move(plid, p, false);
				if (brd.won_by_this(p))   // test whether i have won
					e = (10-depth)*10000L;
				else
					e = -evaluate(id1+id2-plid, -beta, -v, depth+1);
				if (e > v) { v = e; best_move = p; }
				if (v >= beta) done = true;

				brd.back_move(p, false);
				}
			}
		while ( p!= -1 && !done);
		}

	move = best_move;

	return v;
	}

score brain_class::stat_eval(id plid)
	{
	score sum = 0;
	int hori, vert, k;

	for(int t=0; t<=80; t++)
		{
		vert = (t<54)? 1 : 2;
		if ( (k=t%9)<=2 ) hori = 1;
		else if (k>=6) hori = 3;
		else hori = 2;

		if (hori!=3)
			sum += value [ board[t] + board[t+1] + board[t+2] + board[t+3] ];

		if (vert == 2) continue;

		sum += value [ board[t] + board[t+9] + board[t+18] + board[t+27] ];

		if (hori!=3)
			sum += value [ board[t] + board[t+10] + board[t+20] + board[t+30] ];

		if (hori!=1)
			sum += value [ board[t] + board[t+8] + board[t+16] + board[t+24] ];

		}

	if (plid != id1) return (-sum);  // since value table was made for id1

	return sum;
	}

movetype brain_class::make_move()
	{

	gotoxy(1,1);
	evaluate(my_id, start_alpha, start_beta, 0);

	return move;
	}


//class game member functions
void game_class::game_class()
	{
	}

void game_class::intro()
	{

	clrscr();
	textcolor(1);

	cputs("\r\n\r\n");
	cputs("                        -- PLOT 4 --                      \r\n");
	cputs("                  A game by Gaurang Khetan,               \r\n");
	cputs("                Third Year (Electronics), VIT.            \r\n");

	cputs("\r\n To implement computer game play, this game uses the\r\n");
	cputs(" minimax game tree search algorithm with alpha-beta pruning.\r\n");
	cputs("\r\n Rules are simple: \r\n");
	cputs(" Player take turns playing one of their pieces in one of the columns.\r\n");
	cputs(" The piece settles in the lowest unoccupied hole in that column.\r\n");
	cputs(" The one who completes continuous string of 4 of his pieces \r\n");
	cputs("         in a row, column, or diagonal wins the game.\r\n");

	cputs("\r\n Player 1 is Computer/Human (C/H)?");
	char ch;
	do
		ch = getch();
	while (ch!='c' && ch!='C' && ch!= 'h' && ch!= 'H');
	putch(ch);

	if (ch=='H' || ch=='h')
		pl1 = 0;
	else
		{
		cputs("\r\n Computer Search Depth (4/5/6/7/8)?");
		char ch;
		do
			ch = getch();
		while (ch!='4' && ch!='5' && ch!= '6' && ch!= '7' && ch!='8');
		putch(ch);
		pl1 = ch - '0';
		brn1 = new brain_class(id1, pl1);
		assert(brn1);
		}

	cputs("\r\n\n Player 2 is Computer/Human (C/H)?");
	do
		ch = getch();
	while (ch!='c' && ch!='C' && ch!= 'h' && ch!= 'H');
	putch(ch);

	if (ch=='h' || ch=='H')
		pl2 = 0;
	else
		{
		cputs("\r\n Computer Search Depth (4/5/6/7/8)?");
		char ch;
		do
			ch = getch();
		while (ch!='4' && ch!='5' && ch!= '6' && ch!= '7' && ch!='8');
		putch(ch);
		pl2 = ch - '0';
		brn2 = new brain_class(id2, pl2);
		assert(brn2);
		}

	clrscr();
	}

movetype game_class::get_player_move(id an_id)
	{
	movetype move;
	brain_class* brn;
	int pl;
	int pl_num;

	if (an_id==id1)
		{
		brn = brn1; pl = pl1; pl_num = 1;
		}
	else
		{
		brn = brn2; pl = pl2; pl_num = 2;
		}

	if (pl==0)
		{				//get human move
		char str[100];
		sprintf(str, "Player %d - Hit a number(1-9)", pl_num);
		d.set_line(0, str);

		char ch;
		while (true)
			{
			ch = getch();
			if (ch>='1' && ch<='9')
				if (brd.top_col(ch-'1') != -1) break;	//check whether it's full
			if (ch==27) { d.end_graphics(); exit(1); }	//check for escape
			}
		move = ch-'1';

		d.clear_line(1);
		sprintf(str, "Player %d - Human played at column %d", pl_num, move+1);
		d.set_line(1, str);
		}
	else
		{
		if(kbhit())
			if(27==getch())
			{
				d.end_graphics();exit(1);
			}

		char str[100];
		sprintf(str, "Player %d - Computer thinking...", pl_num);
		d.set_line(0, str);

		move = brn->make_move();

		d.clear_line(0);
		sprintf(str, "Player %d - Computer played at column %d", pl_num,move+1);
		d.set_line(1,str);
		}

	return move;
	}

id game_class::play_game()
	{
	boolean done = false;
	id cur_player = id1;
	moves_over = 0;
	movetype move;
	id t;

	while(!done)
		{
		d.show_arrow(cur_player);

		move = get_player_move(cur_player);

		brd.play_move(cur_player, move, true);

		modify_order(move);

		if ( (t=brd.whowon()) != 0 ) return t;
		if ( brd.drawn() ) return 0;

		cur_player = id1+id2-cur_player;
		moves_over++;
		}
	return -1;
	}

void game_class::modify_order(int m)
	{
	int i,j;

	for (i=0; i<=8; i++)
		if (order[i]==m) break;
	order[i] = order[0];
	order[0] = m;

	if ((m+1) <=8)
		{
		for (i=0; i<=8; i++)
			if (order[i]==(m+1)) break;
		order[i] = order[1];
		order[1] = m+1;

		}
	if ((m-1)>=0)
		{
		for (i=0; i<=8; i++)
			if (order[i]==(m-1)) break;
		order[i] = order[2];
		order[2] = m-1;
		}
	}
