//class definitions for plot4.cpp
//to be #include'd in plot4.cpp

class display_class
	{
 private:
	int grd_x, grd_y;
	int cell_wdth, cell_hgt;
	int piece_rad;
	int x1[4], y1[4], x2[4], y2[4]; //for lines to be displayed
	boolean cleared[4];
	int arrow;
	int size[4];

	color back_col, arrow_col;
	color pl1_piece_col, pl2_piece_col;
	color grd_back_col, grd_col;
	color talk_col[4];

 public:
	display_class();

	void init_graphics();
	void end_graphics();

	void set_line(int, char*);
	void clear_line(int);
	void show_score(score);

	void show_arrow(id);
	void clear_arrow();

	void display_grid();
	void show_piece(pos place, id who);

	};

class board_class
	{
 private:
	int tops[9];

	int go_u(int,int);
	int go_d(int,int);
	int go_l(int,int);
	int go_r(int,int);
	int go_lu(int,int);
	int go_ld(int,int);
	int go_ru(int,int);
	int go_rd(int,int);

 public:
	board_class();

	void reset_board();

	int top_col(int);

	void play_move(id, movetype c, boolean);
	movetype next_move(int&);
	void back_move(movetype, boolean);
	boolean won_by_this(movetype);
	id whowon();
	boolean drawn();
	};

class brain_class
	{
 private:
	id my_id;
	score start_alpha, start_beta;
	movetype move;
	int max_depth;
	int value[21];

	score stat_eval(id);
	score evaluate (id, score, score, int);

 public:
	brain_class(id, int);

	void set_depth(int);
	movetype make_move();

	};

class game_class
	{
	int pl1, pl2;

	brain_class *brn1, *brn2;
	id first_player;
	int moves_over;

	movetype get_player_move(id);
	void modify_order(int);

  public:
	game_class();

	void intro();
	id play_game();

	};
